

% clc;clear all;close all;

randn('seed',0);rand('seed',0);
addpath('cimg','dimg','util','solvers')
lambdas =  [0.001 0.003 0.007 ...
    0.01 0.03 0.07 ...
    0.1 0.3 0.7 ...
    1 3 7 ...
    10 30 70 ...
    100 300 700 ...
    1000 3000 7000 ...
    10000 30000 70000];


noiselevels=[10:10:70];
images = {'walkbridge','pepper','mandrill','lenna','lake','jetplane','blonde','cameraman','barbara','boat','pirate','livingroom','house'};
noisetypes = {'Random-Valued','Salt-and-Pepper'};
restorationtypes = {'denoising','deblurring'};
% delete(sprintf('%s.txt',mfilename))
% result = {};
sol =[];
i_result= 1;
for mmm = 1:length(restorationtypes),
    for kkk = 1:length(images),
        for lll = 1:length(noisetypes),
            noisetype =noisetypes{lll};
            dlmwrite(sprintf('%s.txt',mfilename),datestr(now),'-append','delimiter','%s\t');
            mystr = sprintf('restorationtype:%s, noisetype:%s, image:%s',restorationtypes{mmm},noisetypes{lll},images{kkk});
            dlmwrite(sprintf('%s.txt',mfilename),mystr,'-append','delimiter','%s\t');
            psnrs = zeros(length(lambdas),length(noiselevels));
            psnrs1 = zeros(length(lambdas),length(noiselevels));
            psnrs2 = zeros(length(lambdas),length(noiselevels));
            times1 = zeros(length(lambdas),length(noiselevels));
            for jjj = 1:length(noiselevels),
                for iii = 1:length(lambdas),
                    lambda = lambdas(iii);
                    noiselevel = noiselevels(jjj);
                    B_Clean = double(imread(sprintf('%s.png',images{kkk})));
                    
                    corrupted_image_name = sprintf('%s_%s_%s_%d.png',restorationtypes{mmm},images{kkk},noisetype,noiselevel);
                    B_Corrupted =  double(imread(corrupted_image_name));
                    
                    % Generate the mask matrix O
                    O = ones(size(B_Clean));
                    
                    %                     if(strcmp(noisetype,'Salt-and-Pepper'))
                    %                         O(B_Corrupted==max(abs(B_Corrupted(:))))=0;
                    %                         O(B_Corrupted==min(abs(B_Corrupted(:))))=0;
                    %                     end
                    
                    B_Clean = B_Clean/max(abs(B_Clean(:)));
                    B_Corrupted = B_Corrupted/max(abs(B_Corrupted(:)));
                    
                    if(strcmp(restorationtypes{mmm},'denoising'))
                        P = [];
                    else
                        P = GenBlurOper;
                    end
                    p = 2;
                    LargestEig = min(sqrt(sum(abs(P(:))>0)*sum(P(:).*P(:))), sum(abs(P(:))));% Largest Eigenvalue of A'A
                    Amap = @(X)functionAX(P,X,restorationtypes{mmm});
                    Atmap = @(X)functionAX(P',X,restorationtypes{mmm});
                    acc = 1/255;
                    
                    
                    
                    tic;
                    %                     U = tvinpaint(B_Corrupted,lambda,[],P);
                    
                    [sol] = l1tv_admm(sol,B_Corrupted,O,Amap,Atmap,p,lambda,LargestEig,acc,B_Clean);
                    U = sol.U;

                    psnrs(iii,jjj)  = snr_l0(U, B_Clean);
                    psnrs1(iii,jjj) = snr_l1(U, B_Clean);
                    psnrs2(iii,jjj) = snr_l2(U, B_Clean);
                    time111 = toc;
                    time111
                    times1(iii,jjj) = time111;
                    psnrs
                    psnrs1
                    psnrs2
                    %                     figure;
                    %                     subplot(1,3,1); imshow(B_Clean,[]);title('Original','fontsize',13);
                    %                     subplot(1,3,2); imshow(B_Corrupted,[]); title('Corrupted','fontsize',13);
                    %                     subplot(1,3,3); imshow(U,[]); title('Recovered','fontsize',13);
                end
            end
            
            Res = [];
            Res.psnr_l0 = psnrs;
            Res.psnr_l1 = psnrs1;
            Res.psnr_l2 = psnrs2;
            Res.times1 = times1;
            Res.noiselevels = noiselevels;
            Res.lambdas = lambdas;
            Res.noisetype = noisetypes{lll};
            Res.image = images{kkk};
            Res.restorationtype = restorationtypes{mmm};
            result{i_result} = Res;
            i_result=i_result+1;
            
            dlmwrite(sprintf('%s.txt',mfilename),psnrs,'-append');
            dlmwrite(sprintf('%s.txt',mfilename),'optimal values','-append','delimiter','%s\t');
            dlmwrite(sprintf('%s.txt',mfilename),max(psnrs),'-append');
            
            dlmwrite(sprintf('%s.txt',mfilename),psnrs1,'-append');
            dlmwrite(sprintf('%s.txt',mfilename),'optimal values','-append','delimiter','%s\t');
            dlmwrite(sprintf('%s.txt',mfilename),max(psnrs1),'-append');
            
            dlmwrite(sprintf('%s.txt',mfilename),psnrs2,'-append');
            dlmwrite(sprintf('%s.txt',mfilename),'optimal values','-append','delimiter','%s\t');
            dlmwrite(sprintf('%s.txt',mfilename),max(psnrs2),'-append');
            
            dlmwrite (sprintf('%s.txt',mfilename),' ','-append','delimiter','%s\t')
            dlmwrite (sprintf('%s.txt',mfilename),' ','-append','delimiter','%s\t')
            dlmwrite (sprintf('%s.txt',mfilename),' ','-append','delimiter','%s\t')
            save(mfilename,'result');
        end
    end
end


save(mfilename,'result');

