clc;clear all;close all;
randn('seed',0);rand('seed',0);
 
% images = {'cameraman','barbara','boat','pirate','livingroom','house'};



addpath('cimg','dimg','util','solvers')

lambdas =  [10 50];

noiselevels=[10:10:70];
images = {'walkbridge','pepper','mandrill','lenna','lake','jetplane','blonde','cameraman','barbara','boat','pirate','livingroom','house'};
noisetypes = {'Random-Valued','Salt-and-Pepper'};
restorationtypes = {'denoising'};
delete(sprintf('%s.txt',mfilename))

result = {};
i_result=1;



for mmm = 1:length(restorationtypes),
    for kkk = 1:length(images),
        for lll = 1:length(noisetypes),
            noisetype =noisetypes{lll};
            dlmwrite(sprintf('%s.txt',mfilename),datestr(now),'-append','delimiter','%s\t');
            mystr = sprintf('restorationtype:%s, noisetype:%s, image:%s',restorationtypes{mmm},noisetypes{lll},images{kkk});
            dlmwrite(sprintf('%s.txt',mfilename),mystr,'-append','delimiter','%s\t');
            psnrs = zeros(length(lambdas),length(noiselevels));
            psnrs1= zeros(length(lambdas),length(noiselevels));
            psnrs2= zeros(length(lambdas),length(noiselevels));
            times1 = zeros(length(lambdas),length(noiselevels));
            for jjj = 1:length(noiselevels),
                for iii = 1:length(lambdas),
                    lambda = lambdas(iii);
                    noiselevel = noiselevels(jjj);
                    B_Clean = double(imread(sprintf('%s.png',images{kkk})));
                    
                    corrupted_image_name = sprintf('%s_%s_%s_%d.png',restorationtypes{mmm},images{kkk},noisetype,noiselevel);
                    B_Corrupted =  double(imread(corrupted_image_name));
                    B_Clean = B_Clean/max(B_Clean(:));
                    B_Corrupted = B_Corrupted/max(B_Corrupted(:));
                    
                    if(strcmp(restorationtypes{mmm},'denoising'))
                        P = [];
                    else
                        P = GenBlurOper;
                    end
                    
                    Amap = @(X)functionAX(P,X,restorationtypes{mmm});
                    Atmap = @(X)functionAX(P',X,restorationtypes{mmm});
                    
                    
                    
                    %% Yan's Code
                    uexact = B_Clean;
                    f = B_Corrupted;
                    tic
                    if(strcmp(noisetype,'Random-Valued'))
                    [y] = acwmf2(f*255);
                    elseif(strcmp(noisetype,'Salt-and-Pepper'))
                    [y] = amf(f*255,39,0,0);
                    else
                        error('unkwnown type!');
                    end
                    u=y/255;
                    psnrs(iii,jjj) = snr_l0(u, uexact);
                    psnrs1(iii,jjj) = snr_l1(u, uexact);
                    psnrs2(iii,jjj) = snr_l2(u, uexact);
                    times1(iii,jjj) = toc;
                    psnrs
                    psnrs1
                    psnrs2
                    
                    %                     figure;
                    %                     subplot(1,3,1); imshow(B_Clean,[]);title('Original','fontsize',13);
                    %                     subplot(1,3,2); imshow(B_Corrupted,[]); title('Corrupted','fontsize',13);
                    %                     subplot(1,3,3); imshow(u,[]); title('Recovered','fontsize',13);
                    
                end
            end
            
            
            Res = [];
            Res.psnr_l0 = psnrs;
            Res.psnr_l1 = psnrs1;
            Res.psnr_l2 = psnrs2;
            Res.times1 = times1;
            Res.noiselevels = noiselevels;
            Res.lambdas = lambdas;
            Res.noisetype = noisetypes{lll};
            Res.image = images{kkk};
            Res.restorationtype = restorationtypes{mmm};
            result{i_result} = Res;
            i_result=i_result+1;
            
            dlmwrite(sprintf('%s.txt',mfilename),psnrs,'-append');
            dlmwrite(sprintf('%s.txt',mfilename),'optimal values','-append','delimiter','%s\t');
            dlmwrite(sprintf('%s.txt',mfilename),max(psnrs),'-append');

                        dlmwrite(sprintf('%s.txt',mfilename),psnrs1,'-append');
            dlmwrite(sprintf('%s.txt',mfilename),'optimal values','-append','delimiter','%s\t');
            dlmwrite(sprintf('%s.txt',mfilename),max(psnrs1),'-append');

            
            dlmwrite(sprintf('%s.txt',mfilename),psnrs2,'-append');
            dlmwrite(sprintf('%s.txt',mfilename),'optimal values','-append','delimiter','%s\t');
            dlmwrite(sprintf('%s.txt',mfilename),max(psnrs2),'-append');
            
            dlmwrite (sprintf('%s.txt',mfilename),' ','-append','delimiter','%s\t')
            dlmwrite (sprintf('%s.txt',mfilename),' ','-append','delimiter','%s\t')
            dlmwrite (sprintf('%s.txt',mfilename),' ','-append','delimiter','%s\t')
            
        end
    end
end


save(mfilename,'result');